require "remastering/remastertool_const"
require "remastering/pluginBase"

class PluginBaseTest < PluginBase

	#=== プラグイン基底クラスのコンストラクタ
	#
	#プラグインの初期化処理を実施する。
	#
	#復帰値:: なし
	#
	def initialize
		super
	end

	#=== プラグイン形式の取得
	#
	#プラグインの形式を返却する。テストプラグインでは"TEST"を返却する。
	#
	#復帰値:: プラグインタイプ("TEST")
	#
	def get_plugin_type
		PLUGIN_TYPE_TEST
	end

	#=== 自動テスト設定/実行画面のタブ内に表示するWidgetの返却
	#
	#自動テスト設定/実行画面で「ファイルテスト」タブが選択されたときに表示する
	#Widgetを返却する。
	#
	#復帰値:: 自動テスト設定/実行画面のタブ内に表示するWidget
	#
	def get_test_set_widget
		nil
	end

	#=== テスト設定ビューの表示/非表示の切り替え
	#
	#自動テスト設定/実行画面向けにテスト項目設定ビューの表示、非表示の切り替えを行う。
	#
	#mode:: BOOL true=テスト項目設定ビューを表示する、false=表示しない
	#復帰値:: なし
	#
	def show_setting_view(mode)
	end

	#===テストの実行
	#
	#設定されたテスト項目にしたがってテストを実施する。
	#
	#復帰値:: なし
	#
	def exec_test
	end

end